#ifndef _FUNCTIONS_H
#define _FUNCTIONS_H

#include "init.h"

#define LCD_CS	   P0_2
#define LCD_RESET  P0_1
#define LCD_RS	   P0_0

#define DISP_W 132
#define DISP_H 176
#define CHAR_H 14
#define CHAR_W 8
#define TEXT_COL 16
#define TEXT_ROW 12

void lcd_write(unsigned char dat);
void lcd_comtype(unsigned char dat1);
void lcd_comdat(unsigned char dat1, unsigned char dat2);
void lcd_init_c(void);
void lcd_cspulse(void);
void lcd_write16(unsigned int dat);
void fill_screen(unsigned int color);

extern unsigned int backcolor=0xFFFF;    // color of background
extern unsigned int textcolor=0x0000;

void lcd_cspulse(void)
{
  /*PORTB |= _BV(LCD_CS);
  asm volatile("nop");
  PORTB &= ~_BV(LCD_CS);*/

  /* eigener Code */
  LCD_CS = 1;
  _nop_();
  LCD_CS = 0;
}

void lcd_write(unsigned char dat)
{
  //SPDR= dat;
  //while (!(SPSR & _BV(SPIF)));

  /* eigener Code */
  SPDAT = dat;
  while(!spi_transmit);
}

void lcd_comtype(unsigned char dat1)
{
  lcd_write(0x74);  // indicates command type
  lcd_write(0x00);
  lcd_write(dat1);
  lcd_cspulse();
}

void lcd_comdat(unsigned char dat1, unsigned char dat2)
{
  lcd_write(0x76);  // indicates command data
  lcd_write(dat1);
  lcd_write(dat2);
  lcd_cspulse();
}

void lcd_init_c(void)
/*
  Initialization of the LPH-Type display. Note that this display does not need the RS line.
  Instead it uses command type indication and command data indication.
  
  (c) Christian Kranz, 10/2005
*/
{
  unsigned char ct1[6]={0x07,0x02,0x04,0x0C,0x0D,0x0E};
  unsigned char cd1[12]={0x00,0x00, 0x04,0x00, 0x00,0x00, 0x00,0x01, 0x06,0x16, 0x10,0x10};
  unsigned char ct2[2]={0x03,0x0E};
  unsigned char cd2[4]={0x00,0x0C, 0x2D,0x1F};
  unsigned char ct3[1]={0x0D};
  unsigned char cd3[2]={0x06,0x16};
  unsigned char ct4[21]={0x01,0x0F,0x0B,0x11,0x06,0x05,0x14,0x15,0x16,0x17,0x20,0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,0x3A,0x3B};
  unsigned char cd4[42]={0x02,0x15, 0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x00, 0x00,0x30, 0xAF,0x00, 0x00,0x00, 0x83,0x00, 0xAF,0x00,0x00,0x00, 0x00,0x00, 0x04,0x00, 0x02,0x07, 0x07,0x00, 0x00,0x05, 0x07,0x03, 0x07,0x07, 0x00, 0x07, 0x12,0x00, 0x00,0x09};

  unsigned char i,j;

  /*
  // generate clean display reset
  PORTB &= ~_BV(LCD_RESET); // reset display
  PORTB |= _BV(LCD_CS);  // CS is high during reset release
  PORTB |= _BV(LCD_RS);  // RS is not used, set it to high
  _delay_ms(1);
  PORTB |= _BV(LCD_RESET);  // release reset
  _delay_ms(10);

  PORTB &= ~_BV(LCD_CS);  // select display
  */

  /* eigener Code */
  LCD_RESET = 1;
  LCD_CS	= 1;
  LCD_RS	= 1;
  delay_ms(1);
  LCD_RESET = 0;
  delay_ms(10);

  LCD_CS = 0;
  /* eigener Code Ende */

// starts at 58.8ms
  lcd_comtype(0x00);
  lcd_comdat(0x00,0x01);

// starts at 125ms
  j=0;
  for (i=0; i<6; i++)
  {
    lcd_comtype(ct1[i]);
    lcd_comdat(cd1[j],cd1[j+1]);
    j+=2;
  }

// start at 240ms
  j=0;
  for (i=0; i<2; i++)
  {
    lcd_comtype(ct2[i]);
    lcd_comdat(cd2[j],cd2[j+1]);
    j+=2;
  }

// start at 355ms
  j=0;
  for (i=0; i<1; i++)
  {
    lcd_comtype(ct3[i]);
    lcd_comdat(cd3[j],cd3[j+1]);
    j+=2;
  }

// start at 458ms
  j=0;
  for (i=0; i<21; i++)
  {
    lcd_comtype(ct4[i]);
    lcd_comdat(cd4[j],cd4[j+1]);
    j+=2;
  }
  lcd_comtype(0x07);
  lcd_comdat(0x00, 0x05);
  lcd_comtype(0x07);
  lcd_comdat(0x00, 0x25);
  lcd_comtype(0x07);
  lcd_comdat(0x00, 0x27);
  lcd_comtype(0x07);
  lcd_comdat(0x00, 0x37);
// ready for first screen

  /*
  PORTB |= _BV(LCD_CS);  // deselect display 
  */

  /* eigener Code */
  LCD_CS = 1;
}

void fill_screen(unsigned int color)
{
  /*
  uint16_t i;

  PORTB &= ~_BV(LCD_CS);  // select display
  
  lcd_comtype(0x16);
  lcd_comdat(0x83, 0x00);
  lcd_comtype(0x17);
  lcd_comdat(0xAF, 0x00);
  lcd_comtype(0x21);
  lcd_comdat(0x00, 0x00);
  lcd_comtype(0x22);
  lcd_write(0x76);  
  
  // start data transmission  
  for (i=0; i<DISP_W*DISP_H; i++)
    lcd_write16(color);
    
  PORTB |= _BV(LCD_CS);  // deselect display  
  */
  
  /* eigener Code */
  unsigned int i;

  LCD_CS = 0;
  /* eigener Code Ende */ 

  lcd_comtype(0x16);
  lcd_comdat(0x83, 0x00);
  lcd_comtype(0x17);
  lcd_comdat(0xAF, 0x00);
  lcd_comtype(0x21);
  lcd_comdat(0x00, 0x00);
  lcd_comtype(0x22);
  lcd_write(0x76);
  
  for (i=0; i<DISP_W*DISP_H; i++)
    lcd_write16(color);

  /* eigener Code */
  LCD_CS = 1;
  /* eigener Code Ende */   
}
						
void lcd_write16(unsigned int dat)
{
  lcd_write(dat>>8);
  lcd_write(dat);
}

#endif